from distutils.core import setup
from glob import glob

XML_DIR = 'share/xml/giftfile-system'

setup(
    name='giftfile-system',
    version='0.0',
    description='interface to the giftfile system',
    long_description="""
The giftfile system is a specification for marking computer files
containing nonproprietary intellectual works, and an infrastructure
for allowing users of such works to make supporting donations.

Provided here are the basic tools required for participation in this
gift economy.  Currently, it consists of a developer's library written
in Python.

This is a reference implementation developed by the Giftfile Project.
""",
    author='Giftfile Project',
    author_email='info@giftfile.org',
    maintainer='John Belmonte',
    maintainer_email='john@neggie.net',
    url='http://giftfile.org/',
    download_url='http://giftfile.org/development#software',
    package_dir = {'giftfile': 'src/giftfile'},
    packages=['giftfile'],
    data_files=[
        (XML_DIR, ['xml/catalog.xml']),
        (XML_DIR+'/schema/rng', glob('xml/schema/rng/*.rng')),
    ],
    classifiers = [
        'Development Status :: 2 - Pre-Alpha',
        'License :: OSI Approved :: MIT License',
        'Operating System :: POSIX',
        'Programming Language :: Python',
        'Topic :: Software Development :: Libraries',
        'Topic :: Internet',
        'Intended Audience :: Developers',
    ],
)
