# Copyright (C) 2004  John Belmonte

"""John's misc. utilities"""

def indent_text(text, width):
    """Indent text, possibly containing linefeeds, by given width

    Synopsis:
        >>> print 'list:\\n', indent_text('foo\\nbar', 8)
        list:
                foo
                bar
    """
    indent = ' ' * width
    return indent + text.replace('\n', '\n' + indent)

def floor_n(x, num_digits=0):
    """-> floor of x to given precision

    like __builtin__.floor(), but takes a precision as in __builtin__.round()

    Synopsis:
        >>> print floor_n(123.99)
        123.0
        >>> print floor_n(-123.99)
        -124.0
        >>> print floor_n(123.99, 1)
        123.9
        >>> print floor_n(123.99, -1)
        120.0
    """
    return round(x -.5 / 10**num_digits, num_digits)

def _test():
    import doctest
    doctest.testmod()

if __name__ == '__main__':
    _test()
