# Copyright (C) 2004  Anthony Carrico

def flatten (x):
    """Return a tuple without any tuple elements.

    If the original isn't a tuple, return a one-tuple of the original.
    Return the original if it is already flat."""

    if not isinstance (x, tuple):
        return (x,)

    while (len(x) == 1) and isinstance (x[0], tuple):
        x = x[0]

    index = 0
    while (index < len(x)):
        if not isinstance(x[index], tuple):
          index += 1
        else:
            acc = list(x[0:index])
            def recurse(x, index):
              while index < len(x):
                if isinstance(x[index], tuple):
                  recurse(x[index], 0)
                else:
                  acc.append(x[index])
                index += 1
            recurse(x, index)
            return tuple(acc)

    # It is already flat:
    return x

def _test():
    assert flatten(1) == (1,)
    assert flatten(((1,),)) == (1,)
    assert flatten(((1, 2),)) == (1, 2)
    assert flatten(((1, (2,)),)) == (1, 2)
    assert flatten(((((1,),), (2,)),)) == (1, 2)

if __name__ == "__main__":
    _test()


